# Class VulkanImageBlit.Builder

java.lang.Object
com.io7m.jcoronado.api.VulkanImageBlit.Builder

Enclosing class:
  `VulkanImageBlit`

public static final class VulkanImageBlit.Builder extends Object
Builds instances of type `VulkanImageBlit`. Initialize attributes and then invoke the `build()` method to create an immutable instance.

`Builder` is not thread-safe and generally should not be stored in a field or collection, but instead used immediately to create instances.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `VulkanImageBlit`
  `build()`
  Builds a new `VulkanImageBlit`.
  `final VulkanImageBlit.Builder`
  `from(VulkanImageBlitType instance)`
  Fill a builder with attribute values from the provided `VulkanImageBlitType` instance.
  `final VulkanImageBlit.Builder`
  `setSourceOffset0(VulkanOffset3D sourceOffset0)`
  Initializes the value for the `sourceOffset0` attribute.
  `final VulkanImageBlit.Builder`
  `setSourceOffset1(VulkanOffset3D sourceOffset1)`
  Initializes the value for the `sourceOffset1` attribute.
  `final VulkanImageBlit.Builder`
  `setSourceSubresource(VulkanImageSubresourceLayers sourceSubresource)`
  Initializes the value for the `sourceSubresource` attribute.
  `final VulkanImageBlit.Builder`
  `setTargetOffset0(VulkanOffset3D targetOffset0)`
  Initializes the value for the `targetOffset0` attribute.
  `final VulkanImageBlit.Builder`
  `setTargetOffset1(VulkanOffset3D targetOffset1)`
  Initializes the value for the `targetOffset1` attribute.
  `final VulkanImageBlit.Builder`
  `setTargetSubresource(VulkanImageSubresourceLayers targetSubresource)`
  Initializes the value for the `targetSubresource` attribute.

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Method Details

  - ### from

    public final VulkanImageBlit.Builder from(VulkanImageBlitType instance)
    Fill a builder with attribute values from the provided `VulkanImageBlitType` instance. Regular attribute values will be replaced with those from the given instance. Absent optional values will not replace present values.
    Parameters:
      `instance` - The instance from which to copy values
    Returns:
      `this` builder for use in a chained invocation

  - ### setSourceSubresource

    public final VulkanImageBlit.Builder setSourceSubresource(VulkanImageSubresourceLayers sourceSubresource)
    Initializes the value for the `sourceSubresource` attribute.
    Parameters:
      `sourceSubresource` - The value for sourceSubresource
    Returns:
      `this` builder for use in a chained invocation

  - ### setSourceOffset0

    public final VulkanImageBlit.Builder setSourceOffset0(VulkanOffset3D sourceOffset0)
    Initializes the value for the `sourceOffset0` attribute.
    Parameters:
      `sourceOffset0` - The value for sourceOffset0
    Returns:
      `this` builder for use in a chained invocation

  - ### setSourceOffset1

    public final VulkanImageBlit.Builder setSourceOffset1(VulkanOffset3D sourceOffset1)
    Initializes the value for the `sourceOffset1` attribute.
    Parameters:
      `sourceOffset1` - The value for sourceOffset1
    Returns:
      `this` builder for use in a chained invocation

  - ### setTargetSubresource

    public final VulkanImageBlit.Builder setTargetSubresource(VulkanImageSubresourceLayers targetSubresource)
    Initializes the value for the `targetSubresource` attribute.
    Parameters:
      `targetSubresource` - The value for targetSubresource
    Returns:
      `this` builder for use in a chained invocation

  - ### setTargetOffset0

    public final VulkanImageBlit.Builder setTargetOffset0(VulkanOffset3D targetOffset0)
    Initializes the value for the `targetOffset0` attribute.
    Parameters:
      `targetOffset0` - The value for targetOffset0
    Returns:
      `this` builder for use in a chained invocation

  - ### setTargetOffset1

    public final VulkanImageBlit.Builder setTargetOffset1(VulkanOffset3D targetOffset1)
    Initializes the value for the `targetOffset1` attribute.
    Parameters:
      `targetOffset1` - The value for targetOffset1
    Returns:
      `this` builder for use in a chained invocation

  - ### build

    public VulkanImageBlit build()
    Builds a new `VulkanImageBlit`.
    Returns:
      An immutable instance of VulkanImageBlit
    Throws:
      `IllegalStateException` - if any required attributes are missing